function _aws_cdk_aws_scheduler_alpha_ScheduleExpression(p) {
}
function _aws_cdk_aws_scheduler_alpha_CronOptionsWithTimezone(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("timeZone" in p)
            print("@aws-cdk/aws-scheduler-alpha.CronOptionsWithTimezone#timeZone", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_alpha_ScheduleTargetInput(p) {
}
function _aws_cdk_aws_scheduler_alpha_ContextAttribute(p) {
}
function _aws_cdk_aws_scheduler_alpha_ISchedule(p) {
}
function _aws_cdk_aws_scheduler_alpha_TimeWindow(p) {
}
function _aws_cdk_aws_scheduler_alpha_ScheduleProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("schedule" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#schedule", "");
        if (!visitedObjects.has(p.schedule))
            _aws_cdk_aws_scheduler_alpha_ScheduleExpression(p.schedule);
        if ("target" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#target", "");
        if (!visitedObjects.has(p.target))
            _aws_cdk_aws_scheduler_alpha_IScheduleTarget(p.target);
        if ("description" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#description", "");
        if ("enabled" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#enabled", "");
        if ("end" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#end", "");
        if ("group" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#group", "Use `scheduleGroup` instead. `group` will be removed when this module is stabilized.");
        if (!visitedObjects.has(p.group))
            _aws_cdk_aws_scheduler_alpha_IGroup(p.group);
        if ("key" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#key", "");
        if ("scheduleGroup" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#scheduleGroup", "");
        if (!visitedObjects.has(p.scheduleGroup))
            _aws_cdk_aws_scheduler_alpha_IScheduleGroup(p.scheduleGroup);
        if ("scheduleName" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#scheduleName", "");
        if ("start" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#start", "");
        if ("timeWindow" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleProps#timeWindow", "");
        if (!visitedObjects.has(p.timeWindow))
            _aws_cdk_aws_scheduler_alpha_TimeWindow(p.timeWindow);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_alpha_Schedule(p) {
}
function _aws_cdk_aws_scheduler_alpha_GroupProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("groupName" in p)
            print("@aws-cdk/aws-scheduler-alpha.GroupProps#groupName", "");
        if ("removalPolicy" in p)
            print("@aws-cdk/aws-scheduler-alpha.GroupProps#removalPolicy", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_alpha_IGroup(p) {
}
function _aws_cdk_aws_scheduler_alpha_Group(p) {
}
function _aws_cdk_aws_scheduler_alpha_IScheduleTarget(p) {
}
function _aws_cdk_aws_scheduler_alpha_ScheduleTargetConfig(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("arn" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#arn", "");
        if ("role" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#role", "");
        if ("deadLetterConfig" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#deadLetterConfig", "");
        if ("ecsParameters" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#ecsParameters", "");
        if ("eventBridgeParameters" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#eventBridgeParameters", "");
        if ("input" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#input", "");
        if (!visitedObjects.has(p.input))
            _aws_cdk_aws_scheduler_alpha_ScheduleTargetInput(p.input);
        if ("kinesisParameters" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#kinesisParameters", "");
        if ("retryPolicy" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#retryPolicy", "");
        if ("sageMakerPipelineParameters" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#sageMakerPipelineParameters", "");
        if ("sqsParameters" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleTargetConfig#sqsParameters", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_alpha_ScheduleGroupProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("removalPolicy" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleGroupProps#removalPolicy", "");
        if ("scheduleGroupName" in p)
            print("@aws-cdk/aws-scheduler-alpha.ScheduleGroupProps#scheduleGroupName", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_alpha_IScheduleGroup(p) {
}
function _aws_cdk_aws_scheduler_alpha_ScheduleGroup(p) {
}
function print(name, deprecationMessage) {
    const deprecated = process.env.JSII_DEPRECATED;
    const deprecationMode = ["warn", "fail", "quiet"].includes(deprecated) ? deprecated : "warn";
    const message = `${name} is deprecated.\n  ${deprecationMessage.trim()}\n  This API will be removed in the next major release.`;
    switch (deprecationMode) {
        case "fail":
            throw new DeprecationError(message);
        case "warn":
            console.warn("[WARNING]", message);
            break;
    }
}
function getPropertyDescriptor(obj, prop) {
    const descriptor = Object.getOwnPropertyDescriptor(obj, prop);
    if (descriptor) {
        return descriptor;
    }
    const proto = Object.getPrototypeOf(obj);
    const prototypeDescriptor = proto && getPropertyDescriptor(proto, prop);
    if (prototypeDescriptor) {
        return prototypeDescriptor;
    }
    return {};
}
const visitedObjects = new Set();
class DeprecationError extends Error {
    constructor(...args) {
        super(...args);
        Object.defineProperty(this, "name", {
            configurable: false,
            enumerable: true,
            value: "DeprecationError",
            writable: false,
        });
    }
}
module.exports = { print, getPropertyDescriptor, DeprecationError, _aws_cdk_aws_scheduler_alpha_ScheduleExpression, _aws_cdk_aws_scheduler_alpha_CronOptionsWithTimezone, _aws_cdk_aws_scheduler_alpha_ScheduleTargetInput, _aws_cdk_aws_scheduler_alpha_ContextAttribute, _aws_cdk_aws_scheduler_alpha_ISchedule, _aws_cdk_aws_scheduler_alpha_TimeWindow, _aws_cdk_aws_scheduler_alpha_ScheduleProps, _aws_cdk_aws_scheduler_alpha_Schedule, _aws_cdk_aws_scheduler_alpha_GroupProps, _aws_cdk_aws_scheduler_alpha_IGroup, _aws_cdk_aws_scheduler_alpha_Group, _aws_cdk_aws_scheduler_alpha_IScheduleTarget, _aws_cdk_aws_scheduler_alpha_ScheduleTargetConfig, _aws_cdk_aws_scheduler_alpha_ScheduleGroupProps, _aws_cdk_aws_scheduler_alpha_IScheduleGroup, _aws_cdk_aws_scheduler_alpha_ScheduleGroup };
